/**
 * <copyright>
 * </copyright>
 *
 * $Id: AnzeigeQuerschnittModelTypAbstractImpl.java,v 1.1 2012/12/21 10:45:58 Pittner Exp $
 */
package de.bsvrz.buv.plugin.anlagendarstellung.impl;

import de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract;
import de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeQuerschnittModelTypAbstract;

import de.bsvrz.buv.plugin.dobj.model.DoKomponente;
import de.bsvrz.buv.plugin.dobj.model.DoKompositum;
import de.bsvrz.buv.plugin.dobj.model.DobjPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Anzeige Querschnitt Model Typ Abstract</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getKomponenten <em>Komponenten</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getBezeichnung <em>Bezeichnung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getKontext <em>Kontext</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getFahrtrichtung <em>Fahrtrichtung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getDataUpdate <em>Data Update</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.impl.AnzeigeQuerschnittModelTypAbstractImpl#getDarstellungUpdate <em>Darstellung Update</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class AnzeigeQuerschnittModelTypAbstractImpl extends DoModelMitVerbLinieImpl implements AnzeigeQuerschnittModelTypAbstract
{
  /**
   * The cached value of the '{@link #getKomponenten() <em>Komponenten</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKomponenten()
   * @generated
   * @ordered
   */
  protected EList<AnzeigeModelTypAbstract> komponenten;

  /**
   * The default value of the '{@link #getBezeichnung() <em>Bezeichnung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBezeichnung()
   * @generated
   * @ordered
   */
  protected static final String BEZEICHNUNG_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getBezeichnung() <em>Bezeichnung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getBezeichnung()
   * @generated
   * @ordered
   */
  protected String bezeichnung = BEZEICHNUNG_EDEFAULT;

  /**
   * The default value of the '{@link #getKontext() <em>Kontext</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKontext()
   * @generated
   * @ordered
   */
  protected static final int KONTEXT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getKontext() <em>Kontext</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getKontext()
   * @generated
   * @ordered
   */
  protected int kontext = KONTEXT_EDEFAULT;

  /**
   * The default value of the '{@link #getFahrtrichtung() <em>Fahrtrichtung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFahrtrichtung()
   * @generated
   * @ordered
   */
  protected static final int FAHRTRICHTUNG_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getFahrtrichtung() <em>Fahrtrichtung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFahrtrichtung()
   * @generated
   * @ordered
   */
  protected int fahrtrichtung = FAHRTRICHTUNG_EDEFAULT;

  /**
   * The default value of the '{@link #getDataUpdate() <em>Data Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDataUpdate()
   * @generated
   * @ordered
   */
  protected static final Object DATA_UPDATE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDataUpdate() <em>Data Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDataUpdate()
   * @generated
   * @ordered
   */
  protected Object dataUpdate = DATA_UPDATE_EDEFAULT;

  /**
   * The default value of the '{@link #getDarstellungUpdate() <em>Darstellung Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDarstellungUpdate()
   * @generated
   * @ordered
   */
  protected static final Object DARSTELLUNG_UPDATE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDarstellungUpdate() <em>Darstellung Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDarstellungUpdate()
   * @generated
   * @ordered
   */
  protected Object darstellungUpdate = DARSTELLUNG_UPDATE_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AnzeigeQuerschnittModelTypAbstractImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return AnlagendarstellungPackage.Literals.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<AnzeigeModelTypAbstract> getKomponenten()
  {
    if (komponenten == null)
    {
      komponenten = new EObjectContainmentEList<AnzeigeModelTypAbstract>(DoKomponente.class, this, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN);
    }
    return komponenten;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getBezeichnung()
  {
    return bezeichnung;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setBezeichnung(String newBezeichnung)
  {
    String oldBezeichnung = bezeichnung;
    bezeichnung = newBezeichnung;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG, oldBezeichnung, bezeichnung));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getKontext()
  {
    return kontext;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setKontext(int newKontext)
  {
    int oldKontext = kontext;
    kontext = newKontext;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT, oldKontext, kontext));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public int getFahrtrichtung()
  {
    return fahrtrichtung;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFahrtrichtung(int newFahrtrichtung)
  {
    int oldFahrtrichtung = fahrtrichtung;
    fahrtrichtung = newFahrtrichtung;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG, oldFahrtrichtung, fahrtrichtung));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getDataUpdate()
  {
    return dataUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDataUpdate(Object newDataUpdate)
  {
    Object oldDataUpdate = dataUpdate;
    dataUpdate = newDataUpdate;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE, oldDataUpdate, dataUpdate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Object getDarstellungUpdate()
  {
    return darstellungUpdate;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDarstellungUpdate(Object newDarstellungUpdate)
  {
    Object oldDarstellungUpdate = darstellungUpdate;
    darstellungUpdate = newDarstellungUpdate;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE, oldDarstellungUpdate, darstellungUpdate));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN:
        return ((InternalEList<?>)getKomponenten()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN:
        return getKomponenten();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG:
        return getBezeichnung();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT:
        return getKontext();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG:
        return getFahrtrichtung();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE:
        return getDataUpdate();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        return getDarstellungUpdate();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN:
        getKomponenten().clear();
        getKomponenten().addAll((Collection<? extends AnzeigeModelTypAbstract>)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG:
        setBezeichnung((String)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT:
        setKontext((Integer)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG:
        setFahrtrichtung((Integer)newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE:
        setDataUpdate(newValue);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        setDarstellungUpdate(newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN:
        getKomponenten().clear();
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG:
        setBezeichnung(BEZEICHNUNG_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT:
        setKontext(KONTEXT_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG:
        setFahrtrichtung(FAHRTRICHTUNG_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE:
        setDataUpdate(DATA_UPDATE_EDEFAULT);
        return;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        setDarstellungUpdate(DARSTELLUNG_UPDATE_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN:
        return komponenten != null && !komponenten.isEmpty();
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__BEZEICHNUNG:
        return BEZEICHNUNG_EDEFAULT == null ? bezeichnung != null : !BEZEICHNUNG_EDEFAULT.equals(bezeichnung);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KONTEXT:
        return kontext != KONTEXT_EDEFAULT;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__FAHRTRICHTUNG:
        return fahrtrichtung != FAHRTRICHTUNG_EDEFAULT;
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DATA_UPDATE:
        return DATA_UPDATE_EDEFAULT == null ? dataUpdate != null : !DATA_UPDATE_EDEFAULT.equals(dataUpdate);
      case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__DARSTELLUNG_UPDATE:
        return DARSTELLUNG_UPDATE_EDEFAULT == null ? darstellungUpdate != null : !DARSTELLUNG_UPDATE_EDEFAULT.equals(darstellungUpdate);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == DoKompositum.class)
    {
      switch (derivedFeatureID)
      {
        case AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN: return DobjPackage.DO_KOMPOSITUM__KOMPONENTEN;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == DoKompositum.class)
    {
      switch (baseFeatureID)
      {
        case DobjPackage.DO_KOMPOSITUM__KOMPONENTEN: return AnlagendarstellungPackage.ANZEIGE_QUERSCHNITT_MODEL_TYP_ABSTRACT__KOMPONENTEN;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (Bezeichnung: ");
    result.append(bezeichnung);
    result.append(", Kontext: ");
    result.append(kontext);
    result.append(", Fahrtrichtung: ");
    result.append(fahrtrichtung);
    result.append(", DataUpdate: ");
    result.append(dataUpdate);
    result.append(", DarstellungUpdate: ");
    result.append(darstellungUpdate);
    result.append(')');
    return result.toString();
  }

} //AnzeigeQuerschnittModelTypAbstractImpl
