package de.bsvrz.buv.plugin.pua.basis.combinedChart;

import java.util.Collection;

import org.eclipse.swt.widgets.Table;

import de.bsvrz.buv.plugin.pua.basis.expose.IProjektInfo;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.losb.util.Tuple;

/**
 * Schnittstelle fr relevante Daten der Ausgabe eines Protokolls
 * 
 * @author Sans
 *
 */
public interface IProtokollAusgabe
{
  
  public String getId();
  
  public String getName();
  
  public Collection<SystemObject> getObjekte();
  
  public Table getTabelle();
  
  public IProjektInfo getProjektInfo();
  
  public Tuple<Long, Long> getGesamtIntervall();
  
}
