/**
 * <copyright>
 * </copyright>
 *
 * $Id: AnzeigeModelTypAbstract.java,v 1.1 2012/12/21 10:46:03 Pittner Exp $
 */
package de.bsvrz.buv.plugin.anlagendarstellung;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Anzeige Model Typ Abstract</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBezeichnung <em>Bezeichnung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getKontext <em>Kontext</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getInhalte1 <em>Inhalte1</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getInhalte2 <em>Inhalte2</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getDataUpdate <em>Data Update</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getDarstellungUpdate <em>Darstellung Update</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getFahrtrichtung <em>Fahrtrichtung</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getPrioritaet <em>Prioritaet</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBlinken <em>Blinken</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBlinktakt <em>Blinktakt</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getNotwendig <em>Notwendig</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getAbsolutNotwendig <em>Absolut Notwendig</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getVerschiebungVorgaenger <em>Verschiebung Vorgaenger</em>}</li>
 *   <li>{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getVerschiebungNachfolger <em>Verschiebung Nachfolger</em>}</li>
 * </ul>
 * </p>
 *
 * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract()
 * @model abstract="true"
 * @generated
 */
public interface AnzeigeModelTypAbstract extends DoModelMitVerbLinie
{
  /**
   * Returns the value of the '<em><b>Bezeichnung</b></em>' attribute.
   * The default value is <code>""</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Bezeichnung</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Bezeichnung</em>' attribute.
   * @see #setBezeichnung(String)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Bezeichnung()
   * @model default=""
   * @generated
   */
  String getBezeichnung();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBezeichnung <em>Bezeichnung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Bezeichnung</em>' attribute.
   * @see #getBezeichnung()
   * @generated
   */
  void setBezeichnung(String value);

  /**
   * Returns the value of the '<em><b>Kontext</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Kontext</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Kontext</em>' attribute.
   * @see #setKontext(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Kontext()
   * @model
   * @generated
   */
  int getKontext();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getKontext <em>Kontext</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Kontext</em>' attribute.
   * @see #getKontext()
   * @generated
   */
  void setKontext(int value);

  /**
   * Returns the value of the '<em><b>Inhalte1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Inhalte1</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Inhalte1</em>' attribute.
   * @see #setInhalte1(EList)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Inhalte1()
   * @model many="false" transient="true"
   * @generated
   */
  EList<?> getInhalte1();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getInhalte1 <em>Inhalte1</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Inhalte1</em>' attribute.
   * @see #getInhalte1()
   * @generated
   */
  void setInhalte1(EList<?> value);

  /**
   * Returns the value of the '<em><b>Inhalte2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Inhalte2</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Inhalte2</em>' attribute.
   * @see #setInhalte2(EList)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Inhalte2()
   * @model many="false" transient="true"
   * @generated
   */
  EList<?> getInhalte2();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getInhalte2 <em>Inhalte2</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Inhalte2</em>' attribute.
   * @see #getInhalte2()
   * @generated
   */
  void setInhalte2(EList<?> value);

  /**
   * Returns the value of the '<em><b>Data Update</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Data Update</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Data Update</em>' attribute.
   * @see #setDataUpdate(Object)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_DataUpdate()
   * @model
   * @generated
   */
  Object getDataUpdate();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getDataUpdate <em>Data Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Data Update</em>' attribute.
   * @see #getDataUpdate()
   * @generated
   */
  void setDataUpdate(Object value);

  /**
   * Returns the value of the '<em><b>Darstellung Update</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Darstellung Update</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Darstellung Update</em>' attribute.
   * @see #setDarstellungUpdate(Object)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_DarstellungUpdate()
   * @model
   * @generated
   */
  Object getDarstellungUpdate();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getDarstellungUpdate <em>Darstellung Update</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Darstellung Update</em>' attribute.
   * @see #getDarstellungUpdate()
   * @generated
   */
  void setDarstellungUpdate(Object value);

  /**
   * Returns the value of the '<em><b>Fahrtrichtung</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fahrtrichtung</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fahrtrichtung</em>' attribute.
   * @see #setFahrtrichtung(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Fahrtrichtung()
   * @model
   * @generated
   */
  int getFahrtrichtung();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getFahrtrichtung <em>Fahrtrichtung</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fahrtrichtung</em>' attribute.
   * @see #getFahrtrichtung()
   * @generated
   */
  void setFahrtrichtung(int value);

  /**
   * Returns the value of the '<em><b>Prioritaet</b></em>' attribute.
   * The default value is <code>"undefiniert"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Prioritaet</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Prioritaet</em>' attribute.
   * @see #setPrioritaet(String)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Prioritaet()
   * @model default="undefiniert"
   * @generated
   */
  String getPrioritaet();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getPrioritaet <em>Prioritaet</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Prioritaet</em>' attribute.
   * @see #getPrioritaet()
   * @generated
   */
  void setPrioritaet(String value);

  /**
   * Returns the value of the '<em><b>Blinken</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Blinken</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Blinken</em>' attribute.
   * @see #setBlinken(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Blinken()
   * @model
   * @generated
   */
  int getBlinken();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBlinken <em>Blinken</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Blinken</em>' attribute.
   * @see #getBlinken()
   * @generated
   */
  void setBlinken(int value);

  /**
   * Returns the value of the '<em><b>Blinktakt</b></em>' attribute.
   * The default value is <code>"Undefiniert"</code>.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Blinktakt</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Blinktakt</em>' attribute.
   * @see #setBlinktakt(String)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Blinktakt()
   * @model default="Undefiniert"
   * @generated
   */
  String getBlinktakt();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getBlinktakt <em>Blinktakt</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Blinktakt</em>' attribute.
   * @see #getBlinktakt()
   * @generated
   */
  void setBlinktakt(String value);

  /**
   * Returns the value of the '<em><b>Notwendig</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Notwendig</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Notwendig</em>' attribute.
   * @see #setNotwendig(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_Notwendig()
   * @model
   * @generated
   */
  int getNotwendig();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getNotwendig <em>Notwendig</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Notwendig</em>' attribute.
   * @see #getNotwendig()
   * @generated
   */
  void setNotwendig(int value);

  /**
   * Returns the value of the '<em><b>Absolut Notwendig</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Absolut Notwendig</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Absolut Notwendig</em>' attribute.
   * @see #setAbsolutNotwendig(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_AbsolutNotwendig()
   * @model
   * @generated
   */
  int getAbsolutNotwendig();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getAbsolutNotwendig <em>Absolut Notwendig</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Absolut Notwendig</em>' attribute.
   * @see #getAbsolutNotwendig()
   * @generated
   */
  void setAbsolutNotwendig(int value);

  /**
   * Returns the value of the '<em><b>Verschiebung Vorgaenger</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Verschiebung Vorgaenger</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Verschiebung Vorgaenger</em>' attribute.
   * @see #setVerschiebungVorgaenger(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_VerschiebungVorgaenger()
   * @model
   * @generated
   */
  int getVerschiebungVorgaenger();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getVerschiebungVorgaenger <em>Verschiebung Vorgaenger</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Verschiebung Vorgaenger</em>' attribute.
   * @see #getVerschiebungVorgaenger()
   * @generated
   */
  void setVerschiebungVorgaenger(int value);

  /**
   * Returns the value of the '<em><b>Verschiebung Nachfolger</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Verschiebung Nachfolger</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Verschiebung Nachfolger</em>' attribute.
   * @see #setVerschiebungNachfolger(int)
   * @see de.bsvrz.buv.plugin.anlagendarstellung.AnlagendarstellungPackage#getAnzeigeModelTypAbstract_VerschiebungNachfolger()
   * @model
   * @generated
   */
  int getVerschiebungNachfolger();

  /**
   * Sets the value of the '{@link de.bsvrz.buv.plugin.anlagendarstellung.AnzeigeModelTypAbstract#getVerschiebungNachfolger <em>Verschiebung Nachfolger</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Verschiebung Nachfolger</em>' attribute.
   * @see #getVerschiebungNachfolger()
   * @generated
   */
  void setVerschiebungNachfolger(int value);

} // AnzeigeModelTypAbstract
