package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.steuerungskern;

/**
 * Klasse kapselt die Parameter des Steuerungskerns die zu einer Instanzn des Steuerungskerns gehren
 * @author ObertM
 */
public class ParameterSteuerungsKern
{
	/**
	 * Anzahl Iterationen
	 */
  private long _anzahlIterationen;

  /**
   * Zeitraster
   */
  private ParaZeitraster _paraZeitraster = new ParaZeitraster();

  /**
   * Aspekte
   */
  private ParaAspekte _paraAspekte = new ParaAspekte();

  /**
   * Anzeigen
   */
  private ParaAnzeigen _paraAnzeigen = new ParaAnzeigen();
  
	/**
   * Methode liefert anzahlIterationen zurck
   * @return anzahlIterationen
   */
  public long getAnzahlIterationen()
  {
  	return _anzahlIterationen;
  }

	/**
   * Methode setzt die Variable anzahlIterationen
   * @param anzahlIterationen zu bernehmender Wert fr anzahlIterationen
   */
  public void setAnzahlIterationen(long anzahlIterationen)
  {
  	_anzahlIterationen = anzahlIterationen;
  }

	/**
   * Methode liefert paraZeitraster zurck
   * @return paraZeitraster
   */
  public ParaZeitraster getParaZeitraster()
  {
  	return _paraZeitraster;
  }

	/**
   * Methode setzt die Variable paraZeitraster
   * @param paraZeitraster zu bernehmender Wert fr paraZeitraster
   */
  public void setParaZeitraster(ParaZeitraster paraZeitraster)
  {
  	_paraZeitraster = paraZeitraster;
  }

	/**
   * Methode liefert paraAspekte zurck
   * @return paraAspekte
   */
  public ParaAspekte getParaAspekte()
  {
  	return _paraAspekte;
  }

	/**
   * Methode setzt die Variable paraAspekte
   * @param paraAspekte zu bernehmender Wert fr paraAspekte
   */
  public void setParaAspekte(ParaAspekte paraAspekte)
  {
  	_paraAspekte = paraAspekte;
  }

	/**
   * Methode liefert paraAnzeigen zurck
   * @return paraAnzeigen
   */
  public ParaAnzeigen getParaAnzeigen()
  {
  	return _paraAnzeigen;
  }

	/**
   * Methode setzt die Variable paraAnzeigen
   * @param paraAnzeigen zu bernehmender Wert fr paraAnzeigen
   */
  public void setParaAnzeigen(ParaAnzeigen paraAnzeigen)
  {
  	_paraAnzeigen = paraAnzeigen;
  }

  
  
}
