package de.bsvrz.sba.plugin.parameter.steuerungskern.parameter.verriegelung.allgemeineVerriegelungsMatrix;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;

import de.bsvrz.sba.plugin.parameter.steuerungskern.projektspezifischeEinstellungen.AnzeigeElementTyp;

public class CompositeTAQ extends Composite
{
  /**
   * Konstruktor der Klasse
   * @param parent Parent des Composites
   * @param style Style des Composites
   */
	public CompositeTAQ(Composite parent, int style)
  {
	  super(parent, style);
	  
	  this.setBackground(parent.getBackground());
	  
    createComposite();
  }

  /**
   * Methode initialisiert das Composite
   */
  private void createComposite ()
  {
    GridData gd = new GridData();
    gd.horizontalAlignment = GridData.CENTER;
    gd.verticalAlignment = GridData.CENTER;
    gd.grabExcessHorizontalSpace = true;
    gd.grabExcessVerticalSpace = true;

    this.setBackgroundMode( SWT.INHERIT_DEFAULT );
    this.setLayoutData( gd );
    this.setLayout( new GridLayout(1, false) );
    
	  new BildAuswahl ( this, SWT.CENTER | SWT.BORDER, AnzeigeElementTyp.WZG_TAQ);
  }

	public Control getTAQ()
  {
	  return getChildren()[0];
  }
}
