/*******************************************************************************
 * This file is part of Rahmenwerk.
 * 
 * Rahmenwerk is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License  as 
 * published by the Free Software Foundation, either version 3 of the
 * License.
 * 
 * Rahmenwerk is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Rahmenwerk.  If not, see <http://www.gnu.org/licenses/>.
 *  
 *  
 * 
 * Copyright (c) 2012 SWARCO TRAFFIC SYSTEMS GmbH.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 * SWARCO TRAFFIC SYSTEMS GmbH - initial API and implementation
 * 
 * 
 * 
 * Contact Information:
 * SWARCO TRAFFIC SYSTEMS GmbH
 * Adolf-Dambach-Strae 
 * D-76571 Gaggenau
 * Phone: +49-7225-64-03
 * Fax: +49-7225-64-300
 * mailto: office.sts@swarco.de
 ******************************************************************************/
package de.sts.buv.plugin.workflow.tsf.dlg;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

public class ShellOnTop
{
	private static Shell _shell;

	public static Shell getShell(Shell parent, int style)
	{
		// int newStyle = style | SWT.APPLICATION_MODAL; // | SWT.ON_TOP;

		/*
		 * UrlasserDialog, Schalten-Dialog, Schalteempfehlungs-Dialog und
		 * Weiterschalten-Dialog sollen auf dieser Modalittsebene Arbeiten.
		 */
//		int newStyle = style | SWT.APPLICATION_MODAL;
		int newStyle = style | SWT.ON_TOP;

		_shell = new Shell(parent, newStyle);

		// _shell.addFocusListener(new FocusListener()
		// {
		// @Override
		// public void focusLost(FocusEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new FocusListener() {...}.focusLost()");
		// }
		//      
		// @Override
		// public void focusGained(FocusEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new FocusListener() {...}.focusGained()");
		// }
		// });
		//    
		// _shell.addDisposeListener(new DisposeListener()
		// {
		//      
		// @Override
		// public void widgetDisposed(DisposeEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new DisposeListener() {...}.widgetDisposed()");
		// }
		// });
		//
		// _shell.addShellListener(new ShellListener()
		// {
		//      
		// @Override
		// public void shellIconified(ShellEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new ShellListener() {...}.shellIconified()");
		// }
		//      
		// @Override
		// public void shellDeiconified(ShellEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new ShellListener() {...}.shellDeiconified()");
		// }
		//      
		// @Override
		// public void shellDeactivated(ShellEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new ShellListener() {...}.shellDeactivated()");
		// }
		//      
		// @Override
		// public void shellClosed(ShellEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new ShellListener() {...}.shellClosed()");
		// }
		//      
		// @Override
		// public void shellActivated(ShellEvent e)
		// {
		// System.out
		// .println("ShellOnTop.getShell(...).new ShellListener() {...}.shellActivated()");
		// }
		// });

		return _shell;
	}
}
